
package jst.symtab;
import jst.parsetree.*;

import java.util.*;

import jst.symtab.visitor.*;

public class WildcardType extends ActualType {

	protected boolean boundIsUpper;

	protected ReferenceType bound;

	// Argh!  Who should own these?
	public WildcardType(Decl theOwner, String theSimpleName, JstParseTreeBranch theSource) {
    	super(theOwner, theSimpleName, theSource);
    }

	/*
	public WildcardType(Scope newOwner, WildcardType that, Map<TypeParameter, ActualType> swaps) {
		super(newOwner, that, swaps);
	}

	*/

	public void copy(UserType newOwnerUserType, Map<TypeParameter, ActualType> swaps) {
		assert false; // Never copy wildcards.
	}
	
	public WildcardType asWildcardType() {
		return this;
	}

 	public String getCanonicalName() {
       	String result = "TYP_" + simpleName;

		if (bound != null) {
			if (boundIsUpper)
				result += "_EXTENDS_" + bound.getCanonicalName();
			else
				result += "_SUPER_" + bound.getCanonicalName();
		}

		return result;
    }

	public Scope getOwnerScope() {
		return PackageDecl.getDefaultPackage(); // Would null be better?
		// Should the owner be the scope containing the wildcard>
	}

	public void setBound(boolean isUpper, ReferenceType theBound) {
		boundIsUpper = isUpper;
		bound = theBound;
	}

	public ReferenceType getUpperBound() {
		return boundIsUpper? bound : null;
	}

	public ReferenceType getLowerBound() {
		return boundIsUpper? null : bound;
	}

	public boolean assignableFrom(TypeDecl rhs) {
		if (rhs instanceof NullType)
        	return true;

		// I guess that wildcard types aren't compatible with anything.
		return false;
	}

    public void accept(ModelVisitor visitor) {
        visitor.visitWildcardType(this);
    }
}
