package jst.symtab.link;

import jst.app.JSTMessage;
import jst.symtab.*;

public class InterfaceTypeLookup extends UserTypeLookup {
	
	public InterfaceTypeLookup(ScopeLink theQualifier, Identifier name) {
		super(theQualifier, name);
	}

	public InterfaceTypeLookup(Decl newOwner, InterfaceTypeLookup that) {
		super(newOwner, that);
	}
	
	// Copy constructor to convert UserTypeLookup that turned out to be an interface
	// into an InterfaceTypeLookup.  Needed for anonymous inner classes that can subtype
	// an interface or a class.
	public InterfaceTypeLookup(UserTypeLookup that) {
		this(that.qualifier, that.id);
	}

	public InterfaceTypeLookup copy(Decl newOwner) {
		return new InterfaceTypeLookup(newOwner, this);
	}

	protected boolean checkType() {
		return getInterfaceType() != null;
	}

	public InterfaceType getInterfaceType() {
		if (type == null)
			return null;

		UserType userType = type.asUserType();
		if (userType == null)
			return null;

		return userType.asInterface();
	}

	protected JSTMessage getTypeError() {
		return JSTMessage.TYPE_NOT_AN_INTERFACE;
	}
}
