package jst.symtab.link;

import java.lang.reflect.*;
import jst.app.JSTMessage;
import jst.symtab.*;

public class KnownDecl extends ScopeLink {

	protected Decl decl;

	public KnownDecl(Decl theDecl) {
		decl = theDecl;
	}

	public KnownDecl copy(Decl newOwner) {
		return new KnownDecl(newOwner);
	}

	public Decl getDecl() {
		return decl;
	}

	public Scope getScope() {
		return decl.getNearestScope();
	}

	public String getName() {
		return decl.getSimpleName();
	}

	public int getLine() {
		return decl.getSource().getLine();
	}

	public int getColumn() {
		return decl.getSource().getColumn();
	}

	public String getOwnerFileName() {
		return decl.getOwnerFileName();
	}

	public String getFullName() {
		return ""; // Base scope not included in full name.
	}

	public boolean isFirst() {
		return true;
	}

	public boolean resolve() {
		return true;
	}

	protected Scope getOriginScope() {
		return getScope(); // Source & target are the same.
	}

	public boolean isInstance() {
		return Modifier.isStatic(getDecl().getModifier());
	}

	public JSTMessage getMessage() {
		return null;	// Resolve always works.
	}

	public String toString() {
		return getDecl().getSimpleName();
	}
}
