package jst.symtab.link;

import java.util.*;
import jst.app.JSTMessage;
import jst.symtab.*;

public class MethodLookup extends OperationLookup {
	
	protected MethodDecl method;

	public MethodLookup(ScopeLink theQualifier, Identifier name) {
		super(theQualifier, name);
	}

	public MethodLookup(Decl newOwner, MethodLookup that) {
		super(newOwner, that);
	}

	public MethodLookup copy(Decl newOwner) {
		return new MethodLookup(newOwner, this);
	}

	public MethodLookup copyType(Decl newOwner) {
		return copy(newOwner);
	}

	public boolean lookup() {
		if (!resolveTypeArgs())
			return false;

		if (!resolveArgs())
			return false;
		
		if(qualifier.getScope() == null) {
			return false;
		}

		method = qualifier.getScope().lookupMethod(widen(), getName(), /*getTypeArgs(),*/ getArgTypes(), getLooker());

		return method != null;
	}

	protected JSTMessage getError() {
		return JSTMessage.METHOD_NOT_FOUND;
	}

	public OperationDecl getOperationDecl() {
		return getMethodDecl();
	}

	public MethodDecl getMethodDecl() {
		return method;
	}
}
