package jst.symtab.visitor;

import java.util.*;

import jst.app.JSTMessage;
import jst.symtab.*;
import jst.parsetree.*;

public class SuperclassResolver extends CompositionVisitor {

    protected List<JSTMessage> messages;

    public SuperclassResolver() {
        messages = new ArrayList<JSTMessage>();
    }

    public void visitPackageDecl(PackageDecl packageDecl) {
		// Omit SourceFiles.
        visitKids(packageDecl.getTypes());
        visitKids(packageDecl.getSubPackages());
    }

    public void visitClassType(ClassType classType) {
		classType.resolveSuperclass(messages);

        super.visitClassType(classType);
    }

	public List getMessages() {
		return messages;
	}
}
