package parser.parsetree.visitor;
import parser.parsetree.*;

public class PrintParseTreeVisitor extends SyntaxTreeVisitor {

    protected int nesting = 0;

	public void visitBranch(SyntaxTreeBranch branch) {
        if (branch.isAmbiguous())
            print("AMBIGUOUS " + branch.getSymbolType());
        else if (branch.isList())
            print("LIST " + branch.getSymbolType());
        else
            print(branch.getSymbolType().toString());
            // print(branch.getSymbolType().toString() + " " + branch.getSymbolType().getID());

        nesting++;
        super.visitBranch(branch);
        nesting--;
    }

    public void visitLeaf(SyntaxTreeLeaf leaf) {
        print(leaf.toString());
    }

    protected void print(String s) {
        for (int i = 0; i < nesting; i++)
        	System.out.print(" ");

        System.out.println(s);
    }
}
